pthbs

Packaging Through Hashed Build Scripts
git clone https://ccx.te2000.cz/git/pthbs
Log | Files | Refs | Submodules | README

libarchive (3240B)


      1 #!/usr/bin/env pthbs-build
      2 #+musl-cross-make.65f98305f5666435bf0c6b9ccedffae2179ff1b3286752756886f760cf7771d2
      3 #+gnu-make.782c9e6625fd7420e2cd38b847afed19db3b3844cae8a0426a0dbf73e10d78e5
      4 #+busybox.e60885fe93ee85c01831673bb29f0e62a64903f4ce3094e3dc35bc8ec8887ad9
      5 #+busybox-diffutils.4f5a07b29246414b77a7d71b103263af8f1249d75ddcbd9864e00def3d6feded
      6 #+m4.d61a4ef6e5ca207e24ed8bbbd9931e1e0ac2359ed5aae4e384b49d71401b4840
      7 #@untar:-J:sha256:04357661e6717b6941682cde02ad741ae4819c67a260593dfb2431861b251acb:.
      8 
      9 build_env_static() {
     10 	export LD_LIBRARY_PATH="$pthbs_build_environment/library"
     11 	export CPATH="$pthbs_build_environment/include"
     12 	export LDFLAGS="-static -L$pthbs_build_environment/library $LDFLAGS"
     13 }
     14 autotools_config() {
     15 	prefix=/versions/$pthbs_package
     16 	./configure -C \
     17 		--prefix="$prefix" \
     18 		--build="$(${CC:-gcc} -dumpmachine)" \
     19 		--bindir="$prefix/command" \
     20 		--sbindir="$prefix/command" \
     21 		--infodir="$prefix/info" \
     22 		--localedir="$prefix/locale" \
     23 		--mandir="$prefix/man" \
     24 		--libdir="$prefix/library" \
     25 		--docdir="$prefix/doc/libarchive" \
     26 		--datadir="$prefix/data" \
     27 		--datarootdir="$prefix/data" \
     28 		--localstatedir='/var/pthbs' \
     29 		"$@"
     30 
     31 }
     32 
     33 autotools() {
     34 	cd "$1"
     35 	shift
     36 	autotools_config "$@"
     37 	make -j${JOBS:-1} -l$((1+${JOBS:-1}))
     38 	make DESTDIR="$pthbs_destdir" install
     39 }
     40 
     41 autotools_static() {
     42 	build_env_static
     43 	autotools "$@" --enable-static --disable-shared
     44 }
     45 check_static() {
     46 	local exe || true
     47 	exe=$pthbs_destdir/'/versions'/$pthbs_package/$1
     48 	if ! test -f $exe; then
     49 		printf '%s\n' "Error: file '$1' doesn't exist!"
     50 		exit 1
     51 	fi
     52 	interp_info=$(readelf --string-dump=.interp "$exe") || exit $?
     53 	if test x '!=' "x$interp_info"; then
     54 		printf '%s\n' "Error: '$1' is a dynamic binary!"
     55 		exit 1
     56 	fi
     57 }
     58 
     59 
     60 export LDFLAGS=--static
     61 autotools_static libarchive-3.7.2 --without-xml2
     62 
     63 check_static command/bsdtar
     64 check_static command/bsdcpio
     65 
     66 
     67 
     68 cd "$pthbs_destdir/versions/$pthbs_package"
     69 find -type d -o -print | awk -F/ '
     70 BEGIN {
     71 	x["./command/bsdtar"]=1
     72 	x["./command/bsdcpio"]=1
     73 	x["./library/libarchive.a"]=1}
     74 
     75 function r1(s) {
     76 	sub("^[.]/[^/]*", ".", s)
     77 	return s
     78 }
     79 function s1(repl, s) {
     80 	sub("^[.]/[^/]*", "./"repl, s)
     81 	return s
     82 }
     83 function link(src) {
     84 	x[$0]=0
     85 	printf "%s\t%s\n", $0, src
     86 	printf "genlinks >>%s\t%s<<\n", $0, src >>"/dev/stderr"
     87 }
     88 $1!="."{exit 1}
     89 
     90 
     91 $2 == "command" { link($0); next }
     92 $2 == "bin" { link(s1("command", $0)); next }
     93 
     94 $2 == "library.so" { link($0); next }
     95 $2 == "library" { link($0); next }
     96 $2 == "lib" && $NF ~ /\.l?a$/ { link(s1("library", $0)); next }
     97 $2 == "lib" && $NF ~ /\.so(|\..*)$/ { link(s1("library.so", $0)); next }
     98 
     99 $2 == "share" && $3 ~ /^(info|man|doc|icons|terminfo)$/ { link(r1($0)); next }
    100 
    101 $2 == "man" { link($0); next }
    102 $2 == "info" { link($0); next }
    103 $2 == "doc" { link($0); next }
    104 $2 == "icons" { link($0); next }
    105 $2 == "terminfo" { link($0); next }
    106 $2 == "data" { link($0); next }
    107 $2 == "include" { link($0); next }
    108 
    109 { printf "genlinks ##%s## skipped\n", $0 >>"/dev/stderr" }
    110 
    111 END {
    112 	for(fname in x) { printf "DEBUG: x[\"%s\"]=\"%s\"\n", fname, x[fname] >"/dev/stderr" }
    113 	for(fname in x) {
    114 		if(x[fname]) {
    115 			printf "ERROR: missing expected file \"%s\"\n", fname >"/dev/stderr"
    116 			exit 3
    117 		}
    118 	}
    119 }' >.install-links.new
    120 mv .install-links.new .install-links